* ͻ
*                                                                      
*  DATA BASE LIST OF .DBF FILES, INDEXES, TAGS AND RE-BUILD INDEXES    
*                                                                      
*    Menu driven program to list .DBF structures, list .MDX            
*    Index Tags and tag construction, and rebuild all .MDX             
*    tags and indexes.                                                 
*                                                                      
*                                                                      
*  PROGRAM:  SHOW_DBF.PRG                                              
*  AUTHOR:   Alan D. Frazier                                           
*  DATE:     04.19.92                                                  
*  LANGUAGE: Dbase-IV 1.1 x509, DOS, Unix, or MAC version.             
*  REQUIRES: Color Monitor                                             
*                                                                      Ŀ
* ͼ  
*       Thanks to David Love from the Borland BBS for the                 
*       Listdbf, Printtags and Redotags procedures.  I just               
*       put them all together with a menu.  - Alan Frazier (4/92)         
*    


*  Ŀ
*    MAINLINE CODE (following structured code techniques)       
*  
SET STATUS OFF
SET SCOREBOARD OFF
SET CONFIRM ON
SET TALK OFF
SET ECHO OFF

answer = "Y"        && continue switch for check_dbf procedure
All_sw = "N"        && switch to indicate print structure options
is_built = "N"      && switch to indicate if load list is created

DO check_dbf        && check dbf file names prior to erase

IF answer = "N"     && do not continue with program!!
    CLOSE DATABASES
    SET STATUS ON
    SET SCOREBOARD ON
    SET CONFIRM OFF
    SET TALK ON
    RETURN
    ENDIF

DO D_menu1
DEFINE WINDOW full_win FROM 0,1 TO 17,78
ACTIVATE POPUP Menu_01
CLOSE DATABASES
SET STATUS ON
SET SCOREBOARD ON
SET CONFIRM OFF
SET TALK ON
RETURN


* ķ
*   PROCEDURES ...                                             
* Ľ

* Ŀ
*     PROCEDURE TO DEFINE ACTION TAKEN FROM MAIN MENU POPUP   
* 
PROCEDURE Act_1
PARAMETERS bar
gn_barv = bar
DO BANNER

DO CASE
   CASE gn_barv = 2
        SET COLOR OF NORMAL TO gb+*/b
        @ 19,20 SAY "BUILDING DATA FILES, Please wait..."
        DO LISTDBFS
        is_built = "Y"
        SET COLOR OF NORMAL TO w+/b
        @ 19,1  CLEAR TO 22, 79
        DO banner
   CASE gn_barv = 4
        @ 19,1 CLEAR TO 19,70
        IF is_built = "N"
            SET COLOR OF NORMAL TO r+/b
            @ 19,20 SAY "PLEASE BUILD LOAD LIST FIRST!"
            SET COLOR OF NORMAL TO w+/b
            ELSE
                DO liststruct
                DO banner
                ENDIF
   CASE gn_barv = 5
        @ 19,1 CLEAR TO 19,70
        IF is_built = "N"
            SET COLOR OF NORMAL TO r+/b
            @ 19,20 SAY "PLEASE BUILD LOAD LIST FIRST!"
            SET COLOR OF NORMAL TO w+/b
            ELSE
                DO listtags
                DO banner
                ENDIF
   CASE gn_barv = 6
        @ 19,1 CLEAR TO 19,70
        IF is_built = "N"
            SET COLOR OF NORMAL TO r+/b
            @ 19,20 SAY "PLEASE BUILD LOAD LIST FIRST!"
            SET COLOR OF NORMAL TO w+/b
            ELSE
                DO buildtags
                DO banner
                ENDIF
   CASE gn_barv = 9
        DO help_me
        DO banner
   CASE gn_barv = 10
        DEACTIVATE POPUP
        CLOSE DATABASES
        SET STATUS ON
        SET SCOREBOARD ON
        SET CONFIRM OFF
        SET TALK ON
        SET ECHO ON
        RETURN
ENDCASE
RETURN


* Ŀ
*   PROCEDURE TO LIST STRUCTURE AND TAGS         
* 
PROCEDURE LISTSTRUCT
All_sw = "Y"                && set processing switch ON for PrntTags
file_num = 1
USE Dbfs
SCAN
      STORE LEFT( Dbf, AT(".DBF",Dbf)-1 ) TO mdbf
      SELECT SELECT()
      DO PrntTags WITH "&mdbf."
      SELECT ("Dbfs")
      file_num = file_num+1
      ENDSCAN
USE
All_sw = "N"
@ 19,1 CLEAR TO 19,79
RETURN


* Ŀ
*   PROCEDURE TO LIST TAGS ONLY                  
* 
PROCEDURE LISTTAGS
All_sw = "N"                && set processing switch OFF for PrntTags
file_num = 1
USE Dbfs
SCAN
      STORE LEFT( Dbf, AT(".DBF",Dbf)-1 ) TO mdbf
      SELECT SELECT()
      DO PrntTags WITH "&mdbf."
      SELECT ("Dbfs")
      file_num = file_num+1
      ENDSCAN
USE
All_sw = "N"
@ 19,1 CLEAR TO 19,79
RETURN


* Ŀ
*   PROCEDURE TO REBUILD INDEXES                 
* 
PROCEDURE BUILDTAGS
file_num = 1
USE Dbfs
SCAN
      STORE LEFT( Dbf, AT(".DBF",Dbf)-1 ) TO mdbf
      SELECT SELECT()
      DO RedoTags WITH "&mdbf."
      SELECT ("Dbfs")
      file_num = file_num+1
      ENDSCAN
USE
All_sw = "N"
@ 19,1 CLEAR TO 19,79
RETURN


* Ŀ
*   PROCEDURE TO BUILD DATA BASE LIST  (from David Love)      Ŀ
*   
*                  Modified from the original for displays      
*                 
PROCEDURE ListDbfs
   PRIVATE cConsole
   *-- Write the directory of dbf files to a text file (Dbfs.txt)
   *-- First, erase the file if it exists
   IF FILE("Dbfs.txt")
     ERASE dbfs.txt
   ENDIF

   *-- And, erase the dbfs.dbf file if it exists (so won't be included
   *-- in the list)
   IF FILE("Dbfs.dbf")
     ERASE Dbfs.dbf
   ENDIF

   *-- Now, write the dbfs.txt file
   cConsole = SET("CONSOLE")
   SET CONSOLE OFF
   LIST FILES TO FILE dbfs.txt
   SET CONSOLE &cConsole.

   *-- Then, create the file DBFS.DBF
   SET PRINTER TO FILE DBFS.DBF
   SET PRINTER ON
   ??? "{3}{92}{2}{1}{0}{0}{0}{0}{65}{0}{13}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}"+;
   "{0}{0}{0}{0}{0}{0}{0}{0}{89}{0}{68}{66}{70}{0}{0}{0}{0}{0}{0}{0}{0}{67}{3}"+;
   "{0}{44}{85}{12}{0}{0}{0}{1}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{13}{26}"
   SET PRINTER TO
   SET PRINTER OFF

   *-- Now, append dbfs.txt to dbfs.dbf if the record is a dbf listing.
   USE Dbfs
   APPEND FROM Dbfs.txt FOR ".DBF" $ Dbf TYPE SDF

   USE    && can remove this command if you want

   ERASE Dbfs.txt            && don't need it anymore

RETURN

*--EOP: Listdbfs.prg


* Ŀ
*   PROCEDURE TO PRINT STRUCTURE AND/OR TAGS  (from David Love   Ŀ
*   
*                  Modified from the original for displays         
*                
PROCEDURE PrntTags
 parameter cDBF
	
    use (cDBF)
    @ 19,60 SAY "FILE #: " + str(file_num,2,0)

    * check to see if we print DB structure or just tags

    IF all_sw = "Y"
      SET COLOR OF NORMAL TO bg+*/b
      @ 19,10 SAY "LISTING DATA BASE ......please wait a second..."
      SET COLOR OF NORMAL TO w+/b
      SET CONSOLE OFF
      LIST STRUCTURE TO PRINT
      SET CONSOLE ON
      ENDIF

    SET COLOR OF NORMAL TO g+*/b
    @ 19,10 SAY "BUILDING INDEX TAGS......please wait a second..."
    SET COLOR OF NORMAL TO w+/b
   *-- only perform routine if an index tag exists
    if "" # tag( (cdbf), 1)
      private nTags, nMaxTags, cConsole, cTalk

      *-- used to find UNIQUE/DESCENDING/FOR clauses
      cConsole = set("CONSOLE")
      set console off
      if file("RedoTags.txt")
        erase "RedoTags.txt"
      endif
      list stat to file RedoTags.txt

      *-- creates a database file, RedoTags.dbf, which has three 254 char fields
      if file("RedoTags.dbf")
        erase "RedoTags.dbf"
      endif
      set printer to file RedoTags.dbf
      set printer on
      ??? "{3}{92}{1}{24}{0}{0}{0}{0}{129}{0}{251}{2}{0}{0}{0}{0}{0}{0}{0}{0}{0}"+;
      "{0}{0}{0}{0}{0}{0}{0}{0}{0}{201}{0}{84}{65}{71}{83}{49}{0}{0}{0}{0}{0}{0}"+;
      "{67}{3}{0}{26}{84}{254}{0}{0}{0}{1}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{84}"+;
      "{65}{71}{83}{50}{0}{0}{0}{0}{0}{0}"
      ??? "{67}{1}{1}{26}{84}{254}{0}{0}{0}{1}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}"+;
      "{84}{65}{71}{83}{51}{0}{0}{0}{0}{0}{0}{67}{255}{1}{26}{84}{254}{0}{0}{0}"+;
      "{1}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{13}{26}"
      set printer to
      set printer off

      *-- append to RedoTags if the line contains 'TAG:' (no quotes)
      use RedoTags
      append from RedoTags.txt type sdf for "TAG:" $ tags1
      set console &cConsole

      *-- figure out how many tags there are
      nMaxTags = reccount()

      *-- put any 'for' expression(s) in a separate field
      replace all tags3 with iif( at("For:",tags1) > 0, ;
        substr( tags1, at("For:",tags1) + 5) + " " + trim(tags2),"")

      *-- declare an array to hold the info
      declare aTags[nMaxTags,5]

      *-- store descending/unique/for info to the array variables
      go top
      nTags = 1
      do while .not. eof()
        store "(Descending)" $ tags1 to aTags[nTags,3]
        store "(Unique)" $ tags1 to aTags[nTags,4]
        store trim( tags3 ) to aTags[nTags,5]
        nTags = nTags + 1
        skip
      enddo

      *-- store the key expressions and tags to the array
      use (cDBF)
      nTags = 1
      do while "" # tag( (cDBF),nTags )
        store key( (cDBF),nTags ) to aTags[nTags,1]  && grab the key
        store tag( (cDBF),nTags ) to aTags[nTags,2]  && grab the tagname
        nTags = nTags + 1
      enddo
      use   && don't need the file to be open any more


      *-- print each tag with it's key expression
      cTalk = set("talk")
      set talk off
      SET CONSOLE OFF
      set printer on
      ?? "DATABASE: "+cDBF at 0
      ?
      ?? "TAG" at 0
      ?? "KEY EXPRESSION" at 12
      ?
      nTags = 1
      do while nTags <= nMaxTags
        ?? aTags[nTags,2] at 0
        ?? aTags[nTags,1] + ;
          iif(aTags[nTags,3]," descending","") + ;
          iif(aTags[nTags,4]," unique","") + ;
          iif(""#trim(aTags[nTags,5])," for "+trim(aTags[nTags,5]),"") at 12
        ?
	    nTags = nTags + 1
      enddo
      ?
      set printer off
      set talk &cTalk.

      *-- delete the dbf and text files
      erase "RedoTags.dbf"
      erase "RedoTags.txt"

      *-- release the array ...
      release aTags
	
    endif  && check for tags ...
    use  && close database
RETURN

*-- EoP: RedoTags


* Ŀ
*   PROCEDURE TO RE-BUILD DATA BASE TAGS  (from David Love)   Ŀ
*    
*                  Modified from the original for displays       
*                
PROCEDURE RedoTags
	parameter cDBF
	
	use (cDBF)
      SET COLOR OF NORMAL TO bg+/b
      @ 19,10 SAY " Building index for data base:  " + TRIM(cDBF)
      @ 19,60 SAY "FILE #: " + str(file_num,2,0)
      SET COLOR OF NORMAL TO w+/b
      SET CONSOLE OFF

	*-- only perform routine if an index tag exists
    if "" # tag( (cdbf), 1)
      private nTags, nMaxTags, mkey, mtag, cConsole

      *-- used to find UNIQUE/DESCENDING/FOR clauses
      cConsole = set("CONSOLE")
      set console off
      if file("RedoTags.txt")
        erase "RedoTags.txt"
      endif
      list stat to file RedoTags.txt

      *-- creates a database file, RedoTags.dbf, which has three 254 char fields
      if file("RedoTags.dbf")
        erase "RedoTags.dbf"
      endif
      set printer to file RedoTags.dbf
      set printer on
      ??? "{3}{92}{1}{24}{0}{0}{0}{0}{129}{0}{251}{2}{0}{0}{0}{0}{0}{0}{0}{0}{0}"+;
      "{0}{0}{0}{0}{0}{0}{0}{0}{0}{201}{0}{84}{65}{71}{83}{49}{0}{0}{0}{0}{0}{0}"+;
      "{67}{3}{0}{26}{84}{254}{0}{0}{0}{1}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{84}"+;
      "{65}{71}{83}{50}{0}{0}{0}{0}{0}{0}"
      ??? "{67}{1}{1}{26}{84}{254}{0}{0}{0}{1}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}"+;
      "{84}{65}{71}{83}{51}{0}{0}{0}{0}{0}{0}{67}{255}{1}{26}{84}{254}{0}{0}{0}"+;
      "{1}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{0}{13}{26}"
      set printer to
      set printer off

      use RedoTags
      append from RedoTags.txt type sdf for "TAG:" $ tags1
      set console &cConsole

      *-- figure out how many tags there are
      nMaxTags = reccount()

      *-- put any 'for' expression in a separate field
      replace all tags3 with iif( at("For:",tags1) > 0, ;
        substr( tags1, at("For:",tags1) + 5) + " " + trim(tags2),"")

      *-- declare an array to hold the info
      declare aTags[nMaxTags,5]

      *-- store descending/unique/for info to the array variables
      go top
      nTags = 1
      do while .not. eof()
        store "(Descending)" $ tags1 to aTags[nTags,3]
        store "(Unique)" $ tags1 to aTags[nTags,4]
        store trim( tags3 ) to aTags[nTags,5]
        nTags = nTags + 1
        skip
      enddo

      *-- store the key expressions and tags to the array
      use (cDBF)
      nTags = 1
      do while "" # tag( (cDBF),nTags )
        store key( (cDBF),nTags ) to aTags[nTags,1]  && grab the key
        store tag( (cDBF),nTags ) to aTags[nTags,2]  && grab the tagname
        nTags = nTags + 1
      enddo

	  *-- now, delete the tags   
      do while "" # tag( (cDBF),1 )
        delete tag tag( (cDBF),1 )
	  enddo
	  
      *-- rebuild the MDX, tag by tag ...
	  nTags = 1

      activate window full_win
      set console on

	  do while nTags <= nMaxTags
        mkey = aTags[nTags,1] + ;
        iif(aTags[nTags,3]," descending","") + ;
          iif(aTags[nTags,4]," unique","") + ;
          iif(""#trim(aTags[nTags,5])," for "+trim(aTags[nTags,5]),"")
	    mtag = aTags[nTags,2]
        set talk on
        ? "INDEXING ON KEY: " + trim(mkey) + ", TAG: " + trim(mtag)
        index on &mkey. TAG &mtag.
        set talk  off
	    nTags = nTags + 1
	  enddo

      set console off
      deactivate window full_win
	
      *-- delete the dbf and text files
      erase "RedoTags.dbf"
      erase "RedoTags.txt"

      *-- release the array ...
	  release aTags
	
	endif  && check for tags ...
	use  && close database
	
RETURN


* Ŀ
*   PROCEDURE TO CHECK DBF FILE NAMES            
* 
PROCEDURE CHECK_DBF

    DEFINE WINDOW err_1 FROM 5,5 TO 10,75 DOUBLE
    ACTIVATE WINDOW err_1
    SET COLOR OF NORMAL TO rg+/b
    @ 0,1 SAY " CHECKING FOR EXISTING FILES...."
    SET COLOR OF NORMAL TO bg+/b

    IF FILE("Dbfs.dbf")
         answer = "N"
         @ 1,1 SAY " A Data Base File nammed DBFS.DBF exists, continuing    "
         @ 2,1 SAY " with this program will ERASE THIS FILE!!  Continue?    ";
        GET answer FUNCTION "@M N,Y";
        MESSAGE "Enter a 'Y' to Continue, 'N' to Quit (press space bar to change)."
        READ
        IF answer = "Y"
             ERASE Dbfs.dbf
             ENDIF
   ENDIF

    IF FILE("Dbfs.TXT")
         answer = "N"
         @ 1,1 SAY " A Data Base File nammed DBFS.TXT exists, continuing    "
         @ 2,1 SAY " with this program will ERASE THIS FILE!!  Continue?    ";
        GET answer FUNCTION "@M N,Y";
        MESSAGE "Enter a 'Y' to Continue, 'N' to Quit (press space bar to change)."
        READ
        IF answer = "Y"
             ERASE Dbfs.TXT
             ENDIF
   ENDIF

    IF FILE("RedoTags.dbf")
         answer = "N"
         @ 1,1 SAY " A Data Base File nammed REDOTAGS.DBF exists, continuing"
         @ 2,1 SAY " with this program will ERASE THIS FILE!!  Continue?    ";
        GET answer FUNCTION "@M N,Y";
        MESSAGE "Enter a 'Y' to Continue, 'N' to Quit (press space bar to change)."
        READ
        IF answer = "Y"
             ERASE redotags.dbf
             ENDIF
   ENDIF

    IF FILE("RedoTags.TXT")
         answer = "N"
         @ 1,1 SAY " A Data Base File nammed REDOTAGS.TXT exists, continuing"
         @ 2,1 SAY " with this program will ERASE THIS FILE!!  Continue?    ";
        GET answer FUNCTION "@M N,Y";
        MESSAGE "Enter a 'Y' to Continue, 'N' to Quit (press space bar to change)."
        READ
        IF answer = "Y"
             ERASE redotags.txt
             ENDIF
   ENDIF

SET COLOR OF NORMAL TO w+/b
DEACTIVATE WINDOW err_1
RETURN


* Ŀ
*   PROCEDURE TO DEFINE MAIN MENU POPUP          
* 
PROCEDURE D_menu1
    DO BANNER
    SET BORDER TO DOUBLE
    DEFINE POPUP Menu_01 FROM 6,20
    DEFINE BAR 2  OF Menu_01 PROMPT " BUILD DATA BASE LIST        ";
           MESSAGE "Load list of all Data Bases in this directory."
    DEFINE BAR 4  OF Menu_01 PROMPT " LIST STRUCTURE OF DATA BASES";
           MESSAGE "Use load list to list Data Base Structure AND Index Tags."
    DEFINE BAR 5  OF Menu_01 PROMPT " LIST ONLY INDEXES AND TAGS";
           MESSAGE "Use load list to print all Index and Tag Names only."
    DEFINE BAR 6  OF Menu_01 PROMPT " REBUILD INDEXES";
           MESSAGE "Use load list to Rebuild all Indexes and Tags."
    DEFINE BAR 9  OF Menu_01 PROMPT " Access On-Line Help";
           MESSAGE "View the On-Help and documentation information"
    DEFINE BAR 10 OF Menu_01 PROMPT " Exit From This Menu  ";
           MESSAGE "Exit System"
    ON SELECTION POPUP Menu_01 DO Act_1 WITH BAR()
RETURN


* Ŀ
*   PROCEDURE TO DISPLAY BANNER                  
* 
PROCEDURE BANNER

    SET COLOR OF NORMAL TO RG+/B
    @ 2,5 TO 4,75 DOUBLE
    @ 3,10 SAY "MENU FOR DATA BASE INFORMATION SYSTEM"
    SET COLOR OF NORMAL TO W+/B
    RETURN


* Ŀ
*   PROCEDURE TO DISPLAY ON-LINE HELP TEXT       
* 
PROCEDURE HELP_ME

CLEAR
SET COLOR OF NORMAL TO rg+/b
TEXT
  ͸
           DATA BASE INFORMATION SYSTEM - ON-LINE HELP                     
  ;
                                                                           
   This system will gather information regarding all the data base         
   files in the active directory, and print this information or            
   re-index all the files and rebuild all the index tags.                  
                                                                           
   The system creates two new data base files (Dbfs.DBF and RedoTags.DBF)  
   and two text files (Dbfs.TXT and RedoTags.TXT).    These files          
   are used to hold information about the active data base files and       
   indexes/tags.  The current subdirectory is first checked for the        
   existence of these files, and the user is given the option to           
   erase these files, or abort this program before these files are erased. 
                                                                           
   The first option on the menu will create a new data base containing     
   information regarding all the data bases in the active directory.       
   This option should be run before any of the other options are           
   executed.  A message will issued if you run any other option prior to   
   running this menu selection.                                            
  
   (Screen 1 of 2)   More....

ENDTEXT
SET COLOR OF NORMAL TO bg+/b
WAIT
SET COLOR OF NORMAL TO rg+/b
CLEAR
TEXT
  ͸
           DATA BASE INFORMATION SYSTEM - ON-LINE HELP                     
  ;
                                                                           
   The other options on the menu will print the structure and index        
   tags, or just the index tags for all the data bases in the directory.   
                                                                           
   You can also rebuild all indexes and tags for all the data bases        
   in the directory (very usefull for corrupted indexs).                   
                                                                           
   I have found this to be helpfull when working on the development        
   of new applications, or maintaining older systems.                      
                                                                           
   I would like to thank David Love from the Borland BBS for the           
   Print Tags, Re-Do tags procedures I used.                               
                                                                           
           - Alan Frazier,  Systematics Consulting, Inc.  (303) 674-8445   
               April 21, 1992                                              
  
    (Screen 2 of 2)  END...

ENDTEXT
SET COLOR OF NORMAL TO bg+/b
WAIT
CLEAR
SET COLOR OF NORMAL TO w+/b
RETURN

* ͻ
*           END OF PROGRAM                           
* ͼ

